<template src="./createInfoComponent.htm"></template>

<script>

    import Vue from 'vue';
    import SelectComponent from '../../../../../inputs/SelectComponent.vue';
    import DatePickerComponent from '../../../../../inputs/DatePickerComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('select-component', SelectComponent);
    Vue.component('datepicker-component', DatePickerComponent);

    export default {

        data() {

            return {

                baseInfo: {

                    name: '',

                    role_id: '',

                    email: '',

                    dob: '',

                    company_name: '',

                    phone_number: ''
                }
            }
        },

        mixins: [ ValidationErrorsMixin ],

        computed: {

            /**
             * Data for roles select from store getter.
             **/
            selectRolesList() {

                return this.$store.getters.selectRoles;
            }
        },

        watch: {

            /**
             * Push base info to store on each attribute change
             **/
            baseInfo: {

                handler(newBaseInfo) {

                    this.$store.dispatch('setUser', newBaseInfo);
                },

                deep: true
            }
        }
    }

</script>